/**
 *Transmission App
 * Implementing Transmission App
 */
var TransmissionApp = TransmissionApp || {};  //Define Transmission App namespace.
/**
 *Constructor UNAS App
 */
TransmissionApp.App = function () {
    this.id = 'Transmission';
    this.name = 'Transmission';
    this.version = '6.0.21';
    this.active = false;
    this.menuIcon = '/apps/transmission/images/logo.png?v=6.0.19&';
    this.shortcutIcon = '/apps/transmission/images/logo.png?v=6.0.19&';
    //this.entryUrl = '/apps/transmission/transmission_check.html?v=6.0.19&';
    //this.entryHelpUrl = '/apps/transmission/transmission_help.html?v=6.0.19&';
    var self = this;
    this.TransmissionAppWindow = function () {
        if (UNAS.CheckAppState('Transmission')) {
            return false;
        }

        self.window=new MUI.Window({
            id: 'TransmissionAppWindow',
            title: UNAS._('Transmission'),
            icon: '/apps/transmission/images/logo_small.png?v=6.0.19&',
            loadMethod: 'xhr',
            width: 750,
            height: 480,
            maximizable: false,
            resizable: true,
            scrollbars: false,
            resizeLimit: { 'x': [650, 1200], 'y': [450, 900] },
            contentURL: '/apps/transmission/transmission_check.html?v=6.0.19&',
            require: {  css: ['/apps/transmission/css/transmission.css'] },
            onBeforeBuild: function(){UNAS.SetAppOpenedWindow("Transmission",'TransmissionAppWindow')}
        });
    };

    this.TransmissionUninstall = function () {
        UNAS.RemoveDesktopShortcut('Transmission');
        UNAS.RemoveMenu('Transmission');
        //UNAS.RemoveAppFromGroups('Transmission', 'Help');
        UNAS.RemoveAppFromGroups('Transmission', 'ControlPanel');
        UNAS.RemoveAppFromApps('Transmission');
    };
    new UNAS.Menu('UNAS_App_Internet_Menu', this.name, this.menuIcon, 'Transmission', '', this.TransmissionAppWindow);
    new UNAS.DesktopShortcut(this.name, this.shortcutIcon, 'Transmission', this.TransmissionAppWindow);
    //new UNAS.RegisterToAppGroup(this.name, 'ControlPanel', {'Type' : 'Internet', 'Laction' : 3, "Icon": this.shortcutIcon, "Url": this.entryUrl},{});
    //new UNAS.RegisterToAppGroup(this.name, 'Help', {'Type' : 'Internet', 'Laction' : 3, "Icon": this.shortcutIcon, "Url": this.entryHelpUrl},{});
    var OnChangeLanguage = function (e) {
        UNAS.SetMenuTitle('Transmission', UNAS._('Transmission')); //translate menu
        UNAS.SetShortcutTitle('Transmission', UNAS._('Transmission'));
        if (typeof self.window !== 'undefined') {
            UNAS.SetWindowTitle('TransmissionAppWindow', UNAS._('Transmission'));
        }
    };
    UNAS.LoadTranslation('/apps/transmission/languages/Translation?v=' + this.version, OnChangeLanguage);
    UNAS.Event.addEvent('ChangeLanguage', OnChangeLanguage);
    UNAS.CreateApp(this.name, this.shortcutIcon, this.TransmissionAppWindow, this.TransmissionUninstall);
};

new TransmissionApp.App();
 