window.unasEncrypt = null;
window.unasLang = null;

function checkUnasToken(UToken, ULang, callback) {
    window.unasLang = ULang;
    var currentUser = getCurrentUser(window.location.pathname);

    $.ajax({
        url: "/wmi/index.php",
        type: "POST",
        async: false,
        dataType: "json",
        contentType: "application/json",
        data: JSON.stringify({"cmd": "transmission_check_login", "token": UToken, "username": currentUser}),
        success: function (data) {
            if (data.err != 0) {
                $('#id01').show();
                $('.transmission-login-btn').on('click', unas_login);
                return false;
            }
            if (callback) {
                callback();
            }
        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
            alert(textStatus);
        }
    });

}

function unas_login() {
    if ($(".transmission-login-btn").hasClass('disabled')) {
        return false;
    }

    var currentUser = getCurrentUser(window.location.pathname);
    var Username = $.trim($("#transmission-login-username").val());
    var Password = $.trim($("#transmission-login-pwd").val());
    if (Username == "" || Password == "") {
        alert(system.lang.login['Username or Password cannot be empty']);
        return false;
    }

    if (currentUser !== Username) {
        alert(system.lang.login['login failed']);
        return false;
    }

    if (window.unasEncrypt) {
        doUnasLogin();
    } else {
        getPublicKey(function () {
            doUnasLogin();
        });
    }
}

function getCurrentUser(pathname) {
    var username = location.search.getQueryString("username");
    var substr = pathname.match(/tr\/(\S*)\/transmission\/web/) == null ? username : pathname.match(/tr\/(\S*)\/transmission\/web/)[1];
    return substr;
}

function doUnasLogin() {
    var userName = $.trim($("#transmission-login-username").val());
    var userPassword = $.trim($("#transmission-login-pwd").val());
    // userPassword = encryptAndEncodeStr(JSON.stringify(userPassword));
    userPassword = encryptAndEncodeStr(userPassword);

    $(".transmission-login-btn").addClass('disabled');

    var data = {
        cmd: "unas_login",
        params: {
            app: "web",
            device: "pcweb",
            ver: 2,
            uid: userName,
            pwd: userPassword
        }
    };

    jQuery.ajax({
        url: "/wmi/",
        type: "POST",
        async: true,
        dataType: "json",
        data: JSON.stringify(data),
        success: function (data) {
            $(".transmission-login-btn").removeClass('disabled');
            if (data) {
                var _err = parseInt(data.err);
                switch (_err) {
                    case 0: //登陆成功
                        loginSuccess(userName);
                        break;
                    default:
                        alert(system.lang.login['Login failed, Username or Password error']);
                        break;
                }
            } else {
                alert(system.lang.login['login failed']);
                //console.log('登录失败，返回数据为空!!!');
            }
        },
        error: function () {
            $(".transmission-login-btn").removeClass('disabled');
        }
    });
};

function loginSuccess(userName) {
    // var exp = new Date();
    // exp.setTime(exp.getTime() + (86400 * 1000 * 30));
    // document.cookie = "login_user=" + window.btoa(escape(userName)) + "; expires=" + exp.toGMTString() + "; path=/";
    // document.cookie = "login_pwd=" + window.btoa(escape(userPassword)) + "; expires=" + exp.toGMTString() + "; path=/";

    var url = '/tr/' + userName + '/transmission/web/';
    if (window.unasLang) {
        url += '?lang=' + window.unasLang;
    }
    window.location.href = url;
}

function encryptAndEncodeStr(str) {
    if (window.unasEncrypt) {
        str = window.unasEncrypt.encrypt(str);
        str = encodeURI(str).replace(/\+/g, '%2B');
    } else {
        // alert('window.unasEncrypt is null');
    }
    return str;
}


function getPublicKey(cb) {
    $.ajax({
        url: "/wmi/",
        type: "POST",
        async: true,
        dataType: "json",
        data: JSON.stringify({
            cmd: "unas_publickey"
        }),
        success: function (result) {
            if (result.err == 0) {
                var encrypt = new JSEncrypt();
                encrypt.setPublicKey(result.results.publickey);
                window.unasEncrypt = encrypt;

                if (typeof (cb) === 'function') {
                    //console.log('>>>>>>getPublicKey success and unasEncrypt initialized');
                    cb();
                }
            }
        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
            //console.log('>>>>>>getPublicKey error textStatus:'+textStatus);
        }
    });
}

function getCookie(cookieName) {
    var strCookie = document.cookie;
    var arrCookie = strCookie.split("; ");
    for (var i = 0; i < arrCookie.length; i++) {
        var arr = arrCookie[i].split("=");
        if (cookieName == arr[0]) {
            return arr[1];
        }
    }
    return "";
}